--- Predefined values used in the call class object
--
-- @file    callClassDefines.lua
-- @author  Vyacheslav Khudan
-- @created 2015/12/04

----------------------------------------------------------------
-- Defined tables
----------------------------------------------------------------
local classList = {       -- call classes names
     UNKNOWN      = {p = 0,  n = "unknown"}
    ,INTERNAL     = {p = 1,  n = "internal"}
    ,LOCAL        = {p = 2,  n = "local"}
    ,NATIONAL     = {p = 3,  n = "national"}
    ,MOBILE       = {p = 4,  n = "mobile"}
    ,EMERGENCY    = {p = 5,  n = "emergency"}
    ,FREE         = {p = 6,  n = "free"}
    ,PREMIUM1     = {p = 7,  n = "premium1"}
    ,PREMIUM2     = {p = 8,  n = "premium2"}
    ,PREMIUM3     = {p = 9,  n = "premium3"}
    ,PREMIUM4     = {p = 10, n = "premium4"}
    ,NOTRHAMERICA = {p = 11, n = "northamerica"}
    ,AFRICA       = {p = 12, n = "africa"}
    ,EUROPE1      = {p = 13, n = "europe1"}
    ,EUROPE2      = {p = 14, n = "europe2"}
    ,SOUTHAMERICA = {p = 15, n = "southamerica"}
    ,OCEANIA      = {p = 16, n = "oceania"}
    ,RUSSIA       = {p = 17, n = "russia"}
    ,ASIA1        = {p = 18, n = "asia1"}
    ,ASIA2        = {p = 19, n = "asia2"}
    ,SHORTNUMBER  = {p = 20, n = "shortnumber"}
    ,INTERNATIONAL = {p = 21, n = "international"}  -- id 21 hardcoded in permissions.check method
}

local continentsCallClasses = {
     [classList.NOTRHAMERICA] = {"\+1[0-9][0-9].+"}
    ,[classList.AFRICA]       = {"\+2[0-9][0-9].+"}
    ,[classList.EUROPE1]      = {"\+3[0-9][0-9].+"}
    ,[classList.EUROPE2]      = {"\+4[0-9][0-9].+"}
    ,[classList.SOUTHAMERICA] = {"\+5[0-9][0-9].+"}
    ,[classList.OCEANIA]      = {"\+6[0-9][0-9].+"}
    ,[classList.RUSSIA]       = {"\+7[0-9][0-9].+"}
    ,[classList.ASIA1]        = {"\+8[0-9][0-9].+"}
    ,[classList.ASIA2]        = {"\+9[0-9][0-9].+"}
}

local numberType2CallClassMap = {   -- see numberDetectImpl.lua for number type values
     FIX   = classList.NATIONAL
    ,VOIP  = classList.NATIONAL
    ,MOB   = classList.MOBILE
    ,EMER  = classList.EMERGENCY
    ,FREE  = classList.FREE
    ,PREM  = classList.PREMIUM1
    ,PREM2 = classList.PREMIUM2
    ,PREM3 = classList.PREMIUM3
    ,PREM4 = classList.PREMIUM4
} 

local countriesCallClasses = {  -- static regexp of the countries classes. 
                                -- Be carefull with duplicate CC !!! All regexp must be with CC !!!
}

return {
     classList               = classList
    ,continentsCallClasses   = continentsCallClasses
    ,numberType2CallClassMap = numberType2CallClassMap
    ,countriesCallClasses    = countriesCallClasses
}
