--- Testing unite for number detection module
--
-- @file    numberDetectTest.lua
-- @author  Vyacheslav Khudan
-- @created 2015/11/26

----------------------------------------------------------------
-- Numbers look up tests
----------------------------------------------------------------
local numberDetection = require"common.numberDetect.numberDetectImpl":new()

local function __processTest(number, verifyData)
    local result, err = numberDetection:search(number)
    if not result then
        print(string.format("Error [%s]: %s\n", number, err))
        return false
    end
    
    print(string.format("Result data (number - %q [%s]:", number, numberDetection:getTypeName()))
    print(string.format("   country code     - %s", numberDetection:getCountryCode()))
    print(string.format("   country name     - %s", numberDetection:getCountryName()))
    print(string.format("   area code        - %s", numberDetection:getAreaCode()))
    print(string.format("   area description - %s", numberDetection:getAreaDescription()))
    
    if "table" == type(verifyData) then
        print("-- verifying country code: ", verifyData[1] == numberDetection:getCountryCode() and "OK" or "FALSE")
        print("-- verifying country name: ", verifyData[2] == numberDetection:getCountryName() and "OK" or "FALSE")
        print("-- verifying area code: ",    verifyData[3] == numberDetection:getAreaCode() and "OK" or "FALSE")
        print("-- verifying area description: ", verifyData[4] == numberDetection:getAreaDescription() and "OK" or "FALSE")
    end
    print("")
    return true
end

-- set up search number
local searchNumbers = {}
if arg[1] then
    searchNumbers = {{arg[1]}}
else
    searchNumbers = {
         {"+3904611715197", {"39", "Italy",             "0461", "Trento"}}
        ,{"+393463814926",  {"39", "Italy",             "3",    ""}}
        ,{"+4989200060610", {"49", "Germany",           "89",   "Munchen"}}
        ,{"+491721076022",  {"49", "Germany",           "17",   ""}}
        ,{"+33176747983",   {"33", "France",            "176",  "Paris / Hauts-de-Seine"}}
        ,{"+33626853726",   {"33", "France",            "6",    ""}}
        ,{"+00700700711",   {"00", "Unknown",           "",     ""}}
        ,{"+431402102210",  {"43", "Austria",           "1",    "Wien"}}
        ,{"+43140",         {"43", "Austria",           "140",  "Mountain rescue"}}
        ,{"+16786318356",   {"1",  "United States",     "",     ""}}
    }
end

-- processing test
for _, numberData in ipairs(searchNumbers) do
    __processTest(numberData[1], numberData[2])
end

----------------------------------------------------------------
-- Object processing tests
----------------------------------------------------------------
-- double object crating test
local numberDetection2 = require"common.numberDetect.numberDetectImpl":new()
print("Initial object creating - ", "" == numberDetection2:getCountryCode() and "OK" or "FAIL")

os.exit()