--- SMS notifications

-- @file    smsNotifications.lua
-- @author  Yuriy Zveryanskyy
-- @created 2020/10/29

local smsNotifications = {}

--- Send an SMS using send_sms.php script
-- @param fromnum       Sender number
-- @param tonum         Recipient number
-- @param message       Message text
function smsNotifications.send(fromnum, tonum, message)
    local cmd = '/usr/sbin/send_sms.php'

    if fromnum and fromnum ~= "" then
        cmd = cmd .. string.format(' --fromNumber="%s"', fromnum)
    else
        return false, "from number not defined"
    end

    if tonum and tonum ~= "" then
        cmd = cmd .. string.format(' --number="%s"', tonum)
    else
        return false, "to number not defined"
    end

    if message and message ~= "" then
        cmd = cmd .. string.format(' --message64="%s"', require"base64".encode(message))
    else
        return false, "message not present"
    end

    return require"core.pbxutils".exec(cmd .. " &") -- do not wait
end

return smsNotifications
