--- An authorization class for an admin login procedure
-- 
-- @file    adminAuthLogin.lua 
-- @author  Vyacheslav Khudan
-- @created 2018/01/11

package.path = package.path .. ";/usr/local/share/lua/5.1/common/userAuth/?.lua"

--- @module adminAuthLogin
local adminAuthLogin = {}

--- Retrieve admin data directly from backend 
--  without any permissions checking and module initialization
-- @note Only for an internal code using (do not use for any client API)
-- TODO: should be moved to data provider module during refactoring
function adminAuthLogin.getBackendData()
    -- initialize authorization backend
    local authBackend = require"authBackend":new("LDAP")
    if not authBackend then
        return nil, "error authorization backend building"
    end
    
    local rv = authBackend:getData() 
    return rv and rv[2]
end

return adminAuthLogin