--- Module to processing request from dialplan
-- 
-- @file    authDialplanRequest.lua 
-- @author  Vyacheslav Khudan
-- @created 2017/08/14

package.path = package.path .. ";/usr/local/share/lua/5.1/common/userAuth/?.lua"

--- @module authDialplanRequest
local authDialplanRequest = {}

----------------------------------------------------------------
-- Public interface
----------------------------------------------------------------
--- Request parser
-- @param rawData   The input data from the request  
-- @return parsed data table otherwise nil 
function authDialplanRequest.parse(rawData)
    if "table" ~= type(rawData) then
        return nil
    end
    
    -- parsing table
    local parsingTable = {
         requestorIdent = rawData.source
        ,userAgent      = rawData.ua
    }
    
    local data = {}
    for k, v in pairs(parsingTable) do
         data[#data + 1] = k
         data[k]         = v
    end
    
    return 0 ~= #data and data
end

--- Static request checker
-- @param rawData   The input data from the request 
-- @return boolean value 
function authDialplanRequest.staticCheck(rawData)
    local rv = false
    repeat
        if "table" ~= type(rawData) then
            break
        end
        
        if rawData.uri then 
            break
        end
        
        if not rawData.ua then
            break
        end
        
        rv = true
    until true
    
    return rv
end

return authDialplanRequest
