--- HTML parsing module
-- this is libxml2 wrapper based on Wildix modified https://github.com/duhoobo/lua-xpath
-- DO NOT USE original library, it's unable to parse HTML without modifications
-- @file    htmlparser.lua 
-- @author  Yuriy Zveryanskyy
-- @created 2018/12/17

local xpath = require("xpath")

local htmlparser = {}

local parser = {
    selector = nil
}

function parser:find(request)
    local items = self.selector:xpath(request)
    if #items > 0 then
        return items[1]:extract()
    end
end

--- Object constructor
function htmlparser:new(str)
    local obj = {}
    obj.selector = xpath.loads(str) or xpath.loads("<html></html>") -- empty html, not to find any
    setmetatable(obj, {__index = parser})
    return obj
end

return htmlparser
